#ifndef MOD_TTCB
#define MOD_TTCB

#include "mpi.h"
#include "rsa.h"

/*
+--------------------------------------------+
| SERVICOS FORNECIDOS PELA TCB AS APLICACOES |
+--------------------------------------------+
*/

typedef 
  enum {
          get_connection, 	        // pedido de conexao a tcb             	
          end_connection,		// final de conexao
          get_timestamp,		// obter estampilha temporal
          get_id,			// obter id da TCB local
          start_localM,			// iniciar medicao local
          end_localM,			// terminar medicao local	
          exec,				// execucao local 
          start_localFD,		// iniciar detecao de falha local
          end_localFD,			// terminar deteccao de falha local
          start_distributedFD,		// iniciar detecao de falhas distribuida
          msg_received_on_payload,	// recepcao de mensagem no canal de PayLoad
          winfo_to_fifo,		// especifica para que fifo deve ser enviada a informacao
          				// relacionada com um dado porto de comunicacoes
          stop_winfo_port,		// para de enviar winfo respectiva a um porto dado
// TTCB
          get_timestamp_TTCB_enum,		// obter estampilha temporal sincronizada
          localAuthentication_enum,
	  end_connection_TTCB_enum,
          propose_enum,
          decide_enum,
          getRandom_enum,
          getLocalPublicKey_enum,
          getLocalPublicKey_S_enum,
          getLocalTTCBid_enum,
          crashedLocalTTCBid_enum,
          crashedLocalTTCBeid_enum
       } 
Tservice;

typedef struct  {
	Tservice 	srvc;		// identificacao do servico (Tservice)
	int		sizeofmsg;      // tamanho dos parametros do servico
} ReqTcbHeader;




#endif
