/*
	(TTCB)
	Timely Execution Demo Application	

	Pedro Martins <pmartins@di.fc.ul.pt>
	
--[TTCB 1.11]----------------------------------------------------

    (Trusted) Timely Computing Base 
    (C) 1999-2003, Navigators Group 
    		   http://www.navigators.di.fc.ul.pt
    	
------------------------------------------------------------------	
*/	
	
#include "tcb/tcb.h"

descriptor_t tcbDesc;

int main()
{	
	int res,ret;
	TCBtimestamp start_evt,end_evt;
	TCBtimeinterval delay,max_exec;
	Func_Id funcId;
	
	bzero(&tcbDesc,sizeof(descriptor_t));		        		
			
	// open a conection to TCB
	if ( (ret = openTCBConnection(&tcbDesc))<OK)
	{
		printTCBerror(ret);
		printf("On opening a connection...\n");
		exit(1);
	}

	ret = getTCBTimestamp(&tcbDesc,&start_evt);

	if (ret < 0){
		closeTCBConnection(&tcbDesc);
		printTCBerror(ret);
		printf("On getting a local timestamp...\n");
		exit(1);
	}
	
	delay=1000000000;       // 1 second
	max_exec=10000000000;	// 10 seconds
	strcpy(funcId.module,"app_module");
	strcpy(funcId.funcname,"timelyExec");
	strcpy(funcId.wcetname,"timelyExec_wcet");

	ret = startTCBExec(&tcbDesc,start_evt,delay,max_exec,funcId,"",&end_evt);
	
	if (ret<0)
	{	
		closeTCBConnection(&tcbDesc);
		printTCBerror(ret);
		printf("On starting a local execution...\n");
		exit(1);
	}

	printf("Execution started at %llu\n",start_evt);				
	printf("          terminated at %llu\n",end_evt);				
				
	closeTCBConnection(&tcbDesc);
	
	return 0;
}
