
/*
+-------------------------------------------+
| CANAL DE CONTROLO			    |
+-------------------------------------------+
*/

#define SEND_PERIOD		10000000
#define READ_PERIOD		4000000

//PARA SAIR -- mudar aqui implica mudar tb em share_tcb_app.h
#define NUMBER_OF_MACHINES 6            //numero maximo de maquinas possivel

//em nanos
#define SECURITY_MARGIN_FOR_NODE_CRASH_DETECTION  500000 

#define INIT_MSG 1
#define NORMAL_MSG 0

#define SYNC_STATE 0
#define INIT_STATE 1
#define NORMAL_STATE 2

#define NOT_PRESENT 0
#define IN_INIT 1
#define NORMAL 2

typedef struct {
 	unsigned short rndval;  	
 	unsigned long long snd_time;
} roundtripVal;

typedef struct {
	unsigned char seq;
	unsigned long long timestamp;
	unsigned long long snd_time;
} msg_info_type;

typedef struct 
	{
	  unsigned char magic_id;	
	  unsigned char	machine_src_id;    
	  unsigned char seq;		  // para distinguir replicas de msg's 				 
	  unsigned char msg_type;   
	  unsigned long long snd_time;     
	  unsigned long long vclock;     // em microsegundos
	  roundtripVal  RoundTripInfo[NUMBER_OF_MACHINES];	  
	}
msgtr_hdr;	

/*
+-------------------------------------------+
| DISTRIBUTED FAILURE DETECTION		    |
+-------------------------------------------+
*/

typedef struct
	{
		unsigned long r_time_to_failure;          // microseconds
		unsigned long seq_to;                     
		unsigned short destination_port;	
		union {
			//1 bit 
			unsigned short remote_tfd;	
			//For ATES TESTING (15 bits)
			unsigned short value_tdlv;			
		};
	}
info_field;

/*
	-----------
	info_field
	-----------
	 	 16 bits                  16 bits  
	+-------------------------+------------------------+
	|R|		time_to_fa|ilure		   |  r_time_to_failure
	+-+----------+------------+------------------------+
	|     to     |B|           se|q			   |  seq_to
	+------------+------------+----------------------+-+
	|     destination_port    |			 |T|
	+-------------------------+----------------------+-+
	
	R <1bit> =0 means request, 1 means response
	time_to_failure <signed 31 bits> = in microseconds
				when R=0 time_to_failure is the time spec of the message
				when R=1
				     bit 30 of time_of_failure means 0: no fail, 1:fail
				     bit 29 			     0: no lateness degree, 1:lateness degree	
				     bits 0..28			     lateness degree   
	to <8 bits> destination id mask						   
	B  <1 bit> =1 all sites must process the reply
	seq <23 bits> is the sequence of the message: 0..8388607
	
	T remote_tfd <1bit> =0 no Remote TFD, =1 with Remote TFD

	destination_port: application end to adressing  
	
	special codes
	-------------
	seq=0 means no info
*/

