
// ======
// tcb.h 
// ======

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include "tcb/share_app_tcb.h"
#include <errno.h>
#ifdef TTCB
#include "tcb/share_app_ttcb.h"
#endif

// TCB API

int		openTCBConnection(descriptor_t * tcb_desc);
int		closeTCBConnection(descriptor_t * descriptor);
//int		monDistributed(descriptor_t * descriptor,unsigned long bound, double coverage, unsigned long dev, QoSAdaptationMode_t mode, unsigned int port, Func_Id func);
//int		setQoSCoverage(descriptor_t * descriptor,double coverage, unsigned int port);
int		getTCBTimestamp(descriptor_t * descriptor, TCBtimestamp * ts);
int 		getTCBGlobalTimestamp(descriptor_t * descriptor, TCBtimestamp * gts);
int 		getTCBLocalAndGlobalTimestamp(descriptor_t * descriptor, TCBtimestamp * ts, TCBtimestamp * gts);
int		getTCBKernelInfo(descriptor_t * descriptor, tcb_kernel_info_t* kern_inf);
int		getTCBId(descriptor_t * descriptor);
int		startTCBMeasurement(descriptor_t *descriptor,TCBtimestamp ts);
int	        endTCBMeasurement(descriptor_t * descriptor,int measuredesc,TCBtimeinterval* tm,TCBtimestamp* end_ev);
int		startTCBExec(descriptor_t * descriptor,TCBtimestamp start_ev, TCBtimeinterval delay, TCBtimeinterval max_exec,Func_Id func,char* TraceName,TCBtimestamp * end_ts);
int 		startTCBLocalFD(descriptor_t * descriptor,TCBtimestamp start_ev, TCBtimeinterval spec, TCBtimeinterval deadline, Func_Id func);
int 		endTCBLocalFD(descriptor_t * descriptor,int fddesc,TCBtimestamp * end_ev, TCBtimeinterval * procdelay, char * faulty);
int		startTCBDistFD(descriptor_t * descriptor,unsigned char dest_mask,unsigned int dest_port,TCBtimestamp send_evt,TCBtimestamp gsend_evt,TCBtimeinterval spec,TCBtimeinterval deadline,Func_Id func,distAction_id_t *actionid);
int 		startTCBDistWRemoteFD(descriptor_t * descriptor,unsigned char dest_mask,unsigned int dest_port,TCBtimestamp send_evt,TCBtimestamp gsend_evt,TCBtimeinterval spec,distAction_id_t *actionid);
int	        endTCBDistFD(descriptor_t * descriptor, distAction_id_t *actionid, TCBtimestamp * local_rcv_time, TCBtimestamp *global_rcv_time, TCBtimeinterval * procdelay);	
int 		startTCBDistMeasurement(descriptor_t * descriptor, TCBtimestamp send_evt, distAction_id_t *actionid);	
int 		endTCBDistMeasurement(descriptor_t * descriptor, distAction_id_t *actionid, TCBtimestamp * local_rcv_time, TCBtimestamp * global_rcv_time, TCBtimeinterval * procdelay);	
int 	        setTCBRemoteFDHandler(descriptor_t * descriptor, unsigned int port, TCBtimeinterval deadline, Func_Id func);
int             TCBwinfoport(unsigned int port,descriptor_t * descriptor);
int 		TCBwaitInfo(descriptor_t * descriptor,fail_info_to_app* inf);
int             TCBstopwinfoport(unsigned int port,descriptor_t * descriptor);
void 		printTCBerror(int err);		

#define 	TFD_ENABLED(actionId) (actionId->seq!=0?1:0)
#define		UNKNOWN_TIME (t) (t==0xFFFFFFFFFFFFFFFF?1:0)

