#ifndef _RTLINUX_NET_H
#define _RTLINUX_NET_H

#include <linux/config.h>
#include <linux/socket.h>
#include <linux/wait.h>
#include <linux/net.h>

						/* The first 32 are Linux Protos */
#define RT_NPROTO		64		/* should be enough for now..	 */

struct RTsocket
{
	socket_state		state;

	unsigned long		flags;
	struct RTproto_ops	*ops;

//TODO passar para RTsock
	struct sock		*sk;
//TODO: Ver isto
//	wait_queue_head_t	wait;

	short			type;
	pt_obj_list		memmng;
	int 			fd_sock;
};

struct RTproto_ops {
  int	family;

  int	(*release)	(struct RTsocket *sock);
  int	(*bind)		(struct RTsocket *sock, struct sockaddr *umyaddr,
			 int sockaddr_len);
  int	(*socketpair)	(struct RTsocket *sock1, struct RTsocket *sock2);
  int	(*getname)	(struct RTsocket *sock, struct sockaddr *uaddr,
			 int *usockaddr_len, int peer);
  int	(*setsockopt)	(struct RTsocket *sock, int level, int optname,
			 char *optval, int optlen);
  int	(*getsockopt)	(struct RTsocket *sock, int level, int optname,
			 char *optval, int *optlen);
  int   (*sendmsg)	(struct RTsocket *sock, struct msghdr *m, int total_len);
  int   (*recvmsg)	(struct RTsocket *sock, struct msghdr *m, int total_len, int flags);
};

struct RTnet_proto_family 
{
	int	family;
	int	(*create)(struct RTsocket *sock, int protocol);
	/* These are counters for the number of different methods of
	   each we support */
};

struct RTnet_proto 
{
	const char *name;				/* Protocol name */
	void (*init_func)(struct RTnet_proto *);	/* Bootstrap */
};


#endif	/* _LINUX_NET_H */
