/*
 *	main.c 
 *
 *	(C)2002-2003, Navigators Group	<www.navigators.di.fc.ul.pt>
 *		      Pedro Martins	<pmartins@di.fc.ul.pt>
 *	
 *	RTIP main code
 *
 * 	Last Review Date: june 2003
*/


#include <linux/config.h>
#if defined(CONFIG_MODVERSIONS) && !defined(MODVERSIONS)
#	define MODVERSIONS 
#endif

#ifdef MODVERSIONS
#	include <linux/modversions.h>
#endif


#include <linux/config.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/sched.h>
#include <linux/string.h>
#include <linux/timer.h>
#include <linux/errno.h>
#include <linux/in.h>
#include <linux/ioport.h>
#include <linux/slab.h>
#include <linux/interrupt.h>
#include <linux/pci.h>
#include <linux/mii.h>
#include <linux/init.h>
#include <linux/netdevice.h>
#include <linux/etherdevice.h>
#include <linux/skbuff.h>
#include <linux/ethtool.h>
#include <linux/highmem.h>
#include <asm/irq.h>		
#include <asm/bitops.h>
#include <asm/io.h>
#include <asm/uaccess.h>

#include "rtip/RTdev.h"
#include "rtip/RTnet.h"

MODULE_LICENSE("GPL");

unsigned int n_skbuffs=(128*1024)/sizeof(struct RTsk_buff);
//unsigned int n_sockets=(128*1024)/sizeof(struct RTsocket);


MODULE_AUTHOR ("Pedro Martins <pmartins@di.fc.ul.pt>");
MODULE_DESCRIPTION ("RTIP 1.0 - Real-Time Internet Protocol for RTAI");
MODULE_PARM (n_skbuffs,"i");
MODULE_PARM_DESC (n_skbuffs,"number of RTskbuffs to allocate");
//MODULE_PARM (n_sockets,"i");
//MODULE_PARM_DESC (n_sockets,"number of BSD sockets to allocate");

extern struct RTnet_device loopback;

void print_about(void){
	printk("-----------------------------------------------------------------\n");
	printk("RTIP 1.0 - Real-Time IP for RTAI\n");
	printk("(C)2002-2003, Navigators Group <http://www.navigators.di.fc.ul.pt>\n");
	printk("-----------------------------------------------------------------\n");
}

static int __init vortex_init (void)
{	

	print_about();

	printk("\n");

//	RTsock_init(n_sockets);

	printk  ("  .allocating %d RTskbuffs:",n_skbuffs);
	if (initRTskbuffs(n_skbuffs)){
		printk("Memory failure on allocating %d RTsk_buffs -->\n",n_skbuffs);
		return -ENOMEM;
	}
	printk("OK\n");	

	printk ("  .allocating %d RTskbuffs for backlog rx:",n_skbuffs);

	if (rtnet_dev_init(n_skbuffs)){
		printk("Memory failure on allocating %d backlog RTsk_buffs -->\n",n_skbuffs);
		endRTskbuffs();		
		return -ENOMEM;
	}
	printk("OK\n");	

	printk  ("  .starting the built-in loopback device: ");

	//start the loopback device
	if (RTloopback_init(&loopback)){
		printk("Cannot start loopback device\n");
		endRTskbuffs();
		rtnet_dev_close();
		return -ENOMEM;
	}
	printk("OK\n");		

	printk("\nRTIP is running ....\n");

	
	return 0;
}


static void __exit vortex_cleanup (void)
{	
	//ver ordem
//	RTsock_cleanup();		
	endRTskbuffs();
	rtnet_dev_close();	
}


module_init(vortex_init);
module_exit(vortex_cleanup);

