#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/errno.h>
#include "rtip/RTskbuff.h"

//TTCB API (Temporary)
extern int RTsendMessage(char *buff, int size);
extern RTsk_buff* RTreadMessage(void);
extern void RTreleaseMessage(RTsk_buff* buff);
extern int RTgetMTU(void);
extern u64 RTgetMacAddr(void);
extern void RTstartReceive (void);
extern void RTstopReceive (void);

EXPORT_SYMBOL(RTsendMessage);
EXPORT_SYMBOL(RTreadMessage);
EXPORT_SYMBOL(RTreleaseMessage);
EXPORT_SYMBOL(RTgetMTU);
EXPORT_SYMBOL(RTgetMacAddr);
EXPORT_SYMBOL(RTstartReceive);
EXPORT_SYMBOL(RTstopReceive);

//Socket API
//extern long RTIPsocket(int family, int type, int protocol);
//EXPORT_SYMBOL(RTIPsocket);


//Device Driver API
extern struct RTnet_device *RTalloc_etherdev(int sizeof_priv);
extern int RTregister_netdev(struct RTnet_device *dev);
extern void RTunregister_netdev(struct RTnet_device *dev);
extern void __RTkfree_skb(struct RTsk_buff *skb);
extern int RTdev_alloc_name(struct RTnet_device *dev, char *name);
extern int RTnetif_rx(struct RTsk_buff *skb);
extern struct RTsk_buff *RTalloc_skb(void);
extern unsigned short RTeth_type_trans(struct RTsk_buff *skb, struct RTnet_device *dev);
extern void RTskb_copy_and_csum_dev(const struct RTsk_buff *skb, u8 *to);
EXPORT_SYMBOL(RTalloc_etherdev);
EXPORT_SYMBOL(RTregister_netdev);
EXPORT_SYMBOL(RTunregister_netdev);
EXPORT_SYMBOL(__RTkfree_skb);
EXPORT_SYMBOL(RTdev_alloc_name);
EXPORT_SYMBOL(RTnetif_rx);
EXPORT_SYMBOL(RTalloc_skb);
EXPORT_SYMBOL(RTeth_type_trans);
EXPORT_SYMBOL(RTskb_copy_and_csum_dev);

extern void RTnet_dev_get_info(char* buff, struct RTnet_device** next_dev, struct RTnet_device* ndev);
EXPORT_SYMBOL(RTnet_dev_get_info);

















