/*	 
	Process TTCB configuration 

	Pedro Martins		 <pmartins@di.fc.ul.pt>
	Nuno Miguel Neves    	 <nneves@di.fc.ul.pt>

--[TTCB 1.11]----------------------------------------------------

    (Trusted) Timely Computing Base 1.1
    (C) 1999-2003, Navigators Group 
    		   http://www.navigators.di.fc.ul.pt
    
-----------------------------------------------------------------	
*/

#include "../autoconf.h"
#include <stdlib.h>
#include <stdio.h>
#include "tcb/param.h"

FILE* fd,*fd3;

int main(int argc, char* argv[])
{
	fd=fopen("include/tcb/system_defs.h","w");
	if (fd==NULL)
	{
		printf("Error on creating the TTCB configuration file\n");
		exit(1);
	}
	
	fd3=fopen("install.config","w");
	if (fd3==NULL)
	{
		printf("Error on creating the TTCB configuration file\n");
		exit(1);
	}
	
	fprintf(fd,"/* TCB configuration file\n");
	fprintf(fd,"   Generated by process_config... don't edit this file */\n\n\n");

	#ifdef CONFIG_TTCB
	fprintf(fd3,"TTCB=1\n");
	fprintf(fd,"#define TTCB\n");
	#else
	fprintf(fd3,"TTCB=0\n");
	fprintf(fd,"#undef TTCB\n");
	#endif	
        #ifdef CONFIG_JAVAAPI
	fprintf(fd3,"JAVAAPI=1\n");
	#else
	fprintf(fd3,"JAVAAPI=0\n");
        #endif
	#ifdef CONFIG_LOCAL_MEASURE
	fprintf(fd3,"LOCALMEASURE=1\n");
	fprintf(fd,"#define LOCAL_MEASURE\n");
	#else
	fprintf(fd3,"LOCALMEASURE=0\n");
	fprintf(fd,"#undef LOCAL_MEASURE\n");
	#endif
	#ifdef CONFIG_LOCAL_TIMELY
	fprintf(fd3,"LOCALTIMELY=1\n");
	fprintf(fd,"#define LOCAL_TIMELY\n");
	#else
	fprintf(fd3,"LOCALTIMELY=0\n");
	fprintf(fd,"#undef LOCAL_TIMELY\n");
	#endif
	#ifdef CONFIG_LOCAL_FAULT
	fprintf(fd3,"LOCALFAULT=1\n");
	fprintf(fd,"#define LOCAL_FAULT\n");
	#else
	fprintf(fd3,"LOCALFAULT=0\n");
	fprintf(fd,"#undef LOCAL_FAULT\n");
	#endif
	#ifdef CONFIG_LOCAL_RANDOM
	fprintf(fd3,"LOCALRANDOM=1\n");
	fprintf(fd,"#define LOCAL_RANDOM\n");
	#else
	fprintf(fd3,"LOCALRANDOM=0\n");
	fprintf(fd,"#undef LOCAL_RANDOM\n");
	#endif
	#ifdef CONFIG_DIST_SERVICES
	fprintf(fd3,"DISTRIBUTED=1\n");
	fprintf(fd,"#define DISTRIBUTED\n");
	#else
	fprintf(fd3,"DISTRIBUTED=0\n");
	fprintf(fd,"#undef DISTRIBUTED\n");
	#define CONFIG_CC_LO
	#endif
	#ifdef CONFIG_DIST_MEASURE
	fprintf(fd3,"DISTMEASURE=1\n");
	fprintf(fd,"#define DIST_MEASURE\n");
	#else
	fprintf(fd3,"DISTMEASURE=0\n");
	fprintf(fd,"#undef DIST_MEASURE\n");
	#endif
	#ifdef CONFIG_DIST_FAULT
	fprintf(fd3,"DISTFAULT=1\n");
	fprintf(fd,"#define DIST_FAULT\n");
	fprintf(fd,"#define NEED_FUNC_ERR\n");
	#else
	fprintf(fd3,"DISTFAULT=0\n");
	fprintf(fd,"#undef DIST_FAULT\n");
	#endif
	#ifdef CONFIG_DIST_AGREEMENT
	fprintf(fd3,"DISTAGREEMENT=1\n");
	fprintf(fd,"#define DIST_AGREEMENT\n");
	#else
	fprintf(fd3,"DISTAGREEMENT=0\n");
	fprintf(fd,"#undef DIST_AGREEMENT\n");
	#endif

	fprintf(fd3,"RTAI_DIR=%s\n",CONFIG_RTAIDIR);
	#ifdef CONFIG_SC_CC_SIMULATED
	fprintf(fd,"#define CONFIG_SELF_CHECKING_CONTROL_CHANNEL_SIMULATED 1\n");
	#endif	
	#ifdef CONFIG_SC_CC_REAL
	fprintf(fd,"#define CONFIG_SELF_CHECKING_CONTROL_CHANNEL_REAL 1\n");
	#endif
	fclose(fd);
	fclose(fd3);
	return 0;
}

